/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CxTemplateCreateDataHeaderImageUrlsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplateCreateDataHeaderImageUrlsInner{}

// CxTemplateCreateDataHeaderImageUrlsInner struct for CxTemplateCreateDataHeaderImageUrlsInner
type CxTemplateCreateDataHeaderImageUrlsInner struct {
	Url *string `json:"url,omitempty"`
	Language *string `json:"language,omitempty"`
}

// NewCxTemplateCreateDataHeaderImageUrlsInner instantiates a new CxTemplateCreateDataHeaderImageUrlsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplateCreateDataHeaderImageUrlsInner() *CxTemplateCreateDataHeaderImageUrlsInner {
	this := CxTemplateCreateDataHeaderImageUrlsInner{}
	return &this
}

// NewCxTemplateCreateDataHeaderImageUrlsInnerWithDefaults instantiates a new CxTemplateCreateDataHeaderImageUrlsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateCreateDataHeaderImageUrlsInnerWithDefaults() *CxTemplateCreateDataHeaderImageUrlsInner {
	this := CxTemplateCreateDataHeaderImageUrlsInner{}
	return &this
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *CxTemplateCreateDataHeaderImageUrlsInner) GetUrl() string {
	if o == nil || IsNil(o.Url) {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateCreateDataHeaderImageUrlsInner) GetUrlOk() (*string, bool) {
	if o == nil || IsNil(o.Url) {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *CxTemplateCreateDataHeaderImageUrlsInner) HasUrl() bool {
	if o != nil && !IsNil(o.Url) {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *CxTemplateCreateDataHeaderImageUrlsInner) SetUrl(v string) {
	o.Url = &v
}

// GetLanguage returns the Language field value if set, zero value otherwise.
func (o *CxTemplateCreateDataHeaderImageUrlsInner) GetLanguage() string {
	if o == nil || IsNil(o.Language) {
		var ret string
		return ret
	}
	return *o.Language
}

// GetLanguageOk returns a tuple with the Language field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateCreateDataHeaderImageUrlsInner) GetLanguageOk() (*string, bool) {
	if o == nil || IsNil(o.Language) {
		return nil, false
	}
	return o.Language, true
}

// HasLanguage returns a boolean if a field has been set.
func (o *CxTemplateCreateDataHeaderImageUrlsInner) HasLanguage() bool {
	if o != nil && !IsNil(o.Language) {
		return true
	}

	return false
}

// SetLanguage gets a reference to the given string and assigns it to the Language field.
func (o *CxTemplateCreateDataHeaderImageUrlsInner) SetLanguage(v string) {
	o.Language = &v
}

func (o CxTemplateCreateDataHeaderImageUrlsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplateCreateDataHeaderImageUrlsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Url) {
		toSerialize["url"] = o.Url
	}
	if !IsNil(o.Language) {
		toSerialize["language"] = o.Language
	}
	return toSerialize, nil
}

type NullableCxTemplateCreateDataHeaderImageUrlsInner struct {
	value *CxTemplateCreateDataHeaderImageUrlsInner
	isSet bool
}

func (v NullableCxTemplateCreateDataHeaderImageUrlsInner) Get() *CxTemplateCreateDataHeaderImageUrlsInner {
	return v.value
}

func (v *NullableCxTemplateCreateDataHeaderImageUrlsInner) Set(val *CxTemplateCreateDataHeaderImageUrlsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplateCreateDataHeaderImageUrlsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplateCreateDataHeaderImageUrlsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplateCreateDataHeaderImageUrlsInner(val *CxTemplateCreateDataHeaderImageUrlsInner) *NullableCxTemplateCreateDataHeaderImageUrlsInner {
	return &NullableCxTemplateCreateDataHeaderImageUrlsInner{value: val, isSet: true}
}

func (v NullableCxTemplateCreateDataHeaderImageUrlsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplateCreateDataHeaderImageUrlsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


